diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/examples/wireless/wifi-ofdm-ht-validation.cc ns-3.40/examples/wireless/wifi-ofdm-ht-validation.cc
--- ns-3.39/examples/wireless/wifi-ofdm-ht-validation.cc	2023-07-05 14:23:47.669427000 -0700
+++ ns-3.40/examples/wireless/wifi-ofdm-ht-validation.cc	2023-09-27 13:30:37.610839000 -0700
@@ -35,7 +35,7 @@
 int
 main(int argc, char* argv[])
 {
-    uint32_t FrameSize = 1500; // bytes
+    uint32_t frameSizeBytes = 1500;
     std::ofstream yansfile("yans-frame-success-rate-n.plt");
     std::ofstream nistfile("nist-frame-success-rate-n.plt");
     std::ofstream tablefile("table-frame-success-rate-n.plt");
@@ -52,7 +52,7 @@
     };
 
     CommandLine cmd(__FILE__);
-    cmd.AddValue("FrameSize", "The frame size in bytes", FrameSize);
+    cmd.AddValue("FrameSize", "The frame size in bytes", frameSizeBytes);
     cmd.Parse(argc, argv);
 
     Gnuplot yansplot = Gnuplot("yans-frame-success-rate-n.eps");
@@ -64,48 +64,45 @@
     Ptr<NistErrorRateModel> nist = CreateObject<NistErrorRateModel>();
     Ptr<TableBasedErrorRateModel> table = CreateObject<TableBasedErrorRateModel>();
 
-    for (uint32_t i = 0; i < modes.size(); i++)
+    uint32_t frameSizeBits = frameSizeBytes * 8;
+
+    for (const auto& mode : modes)
     {
-        std::cout << modes[i] << std::endl;
-        Gnuplot2dDataset yansdataset(modes[i]);
-        Gnuplot2dDataset nistdataset(modes[i]);
-        Gnuplot2dDataset tabledataset(modes[i]);
-        txVector.SetMode(modes[i]);
+        std::cout << mode << std::endl;
+        Gnuplot2dDataset yansdataset(mode);
+        Gnuplot2dDataset nistdataset(mode);
+        Gnuplot2dDataset tabledataset(mode);
+        txVector.SetMode(mode);
+
+        WifiMode wifiMode(mode);
 
-        for (double snr = -5.0; snr <= 30.0; snr += 0.1)
+        for (double snrDb = -5.0; snrDb <= 30.0; snrDb += 0.1)
         {
-            double ps = yans->GetChunkSuccessRate(WifiMode(modes[i]),
-                                                  txVector,
-                                                  std::pow(10.0, snr / 10.0),
-                                                  FrameSize * 8);
+            double snr = std::pow(10.0, snrDb / 10.0);
+
+            double ps = yans->GetChunkSuccessRate(wifiMode, txVector, snr, frameSizeBits);
             if (ps < 0.0 || ps > 1.0)
             {
                 // error
                 exit(1);
             }
-            yansdataset.Add(snr, ps);
+            yansdataset.Add(snrDb, ps);
 
-            ps = nist->GetChunkSuccessRate(WifiMode(modes[i]),
-                                           txVector,
-                                           std::pow(10.0, snr / 10.0),
-                                           FrameSize * 8);
+            ps = nist->GetChunkSuccessRate(wifiMode, txVector, snr, frameSizeBits);
             if (ps < 0.0 || ps > 1.0)
             {
                 // error
                 exit(1);
             }
-            nistdataset.Add(snr, ps);
+            nistdataset.Add(snrDb, ps);
 
-            ps = table->GetChunkSuccessRate(WifiMode(modes[i]),
-                                            txVector,
-                                            std::pow(10.0, snr / 10.0),
-                                            FrameSize * 8);
+            ps = table->GetChunkSuccessRate(wifiMode, txVector, snr, frameSizeBits);
             if (ps < 0.0 || ps > 1.0)
             {
                 // error
                 exit(1);
             }
-            tabledataset.Add(snr, ps);
+            tabledataset.Add(snrDb, ps);
         }
 
         yansplot.AddDataset(yansdataset);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/examples/wireless/wifi-ofdm-validation.cc ns-3.40/examples/wireless/wifi-ofdm-validation.cc
--- ns-3.39/examples/wireless/wifi-ofdm-validation.cc	2023-07-05 14:23:47.669427000 -0700
+++ ns-3.40/examples/wireless/wifi-ofdm-validation.cc	2023-09-27 13:30:37.610839000 -0700
@@ -37,7 +37,7 @@
 int
 main(int argc, char* argv[])
 {
-    uint32_t FrameSize = 1500; // bytes
+    uint32_t frameSizeBytes = 1500;
     std::ofstream yansfile("yans-frame-success-rate-ofdm.plt");
     std::ofstream nistfile("nist-frame-success-rate-ofdm.plt");
     std::ofstream tablefile("table-frame-success-rate-ofdm.plt");
@@ -54,7 +54,7 @@
     };
 
     CommandLine cmd(__FILE__);
-    cmd.AddValue("FrameSize", "The frame size in bytes", FrameSize);
+    cmd.AddValue("FrameSize", "The frame size in bytes", frameSizeBytes);
     cmd.Parse(argc, argv);
 
     Gnuplot yansplot = Gnuplot("yans-frame-success-rate-ofdm.eps");
@@ -66,48 +66,45 @@
     Ptr<TableBasedErrorRateModel> table = CreateObject<TableBasedErrorRateModel>();
     WifiTxVector txVector;
 
-    for (uint32_t i = 0; i < modes.size(); i++)
+    uint32_t frameSizeBits = frameSizeBytes * 8;
+
+    for (const auto& mode : modes)
     {
-        std::cout << modes[i] << std::endl;
-        Gnuplot2dDataset yansdataset(modes[i]);
-        Gnuplot2dDataset nistdataset(modes[i]);
-        Gnuplot2dDataset tabledataset(modes[i]);
-        txVector.SetMode(modes[i]);
+        std::cout << mode << std::endl;
+        Gnuplot2dDataset yansdataset(mode);
+        Gnuplot2dDataset nistdataset(mode);
+        Gnuplot2dDataset tabledataset(mode);
+        txVector.SetMode(mode);
+
+        WifiMode wifiMode(mode);
 
-        for (double snr = -5.0; snr <= 30.0; snr += 0.1)
+        for (double snrDb = -5.0; snrDb <= 30.0; snrDb += 0.1)
         {
-            double ps = yans->GetChunkSuccessRate(WifiMode(modes[i]),
-                                                  txVector,
-                                                  std::pow(10.0, snr / 10.0),
-                                                  FrameSize * 8);
+            double snr = std::pow(10.0, snrDb / 10.0);
+
+            double ps = yans->GetChunkSuccessRate(wifiMode, txVector, snr, frameSizeBits);
             if (ps < 0.0 || ps > 1.0)
             {
                 // error
                 exit(1);
             }
-            yansdataset.Add(snr, ps);
+            yansdataset.Add(snrDb, ps);
 
-            ps = nist->GetChunkSuccessRate(WifiMode(modes[i]),
-                                           txVector,
-                                           std::pow(10.0, snr / 10.0),
-                                           FrameSize * 8);
+            ps = nist->GetChunkSuccessRate(wifiMode, txVector, snr, frameSizeBits);
             if (ps < 0.0 || ps > 1.0)
             {
                 // error
                 exit(1);
             }
-            nistdataset.Add(snr, ps);
+            nistdataset.Add(snrDb, ps);
 
-            ps = table->GetChunkSuccessRate(WifiMode(modes[i]),
-                                            txVector,
-                                            std::pow(10.0, snr / 10.0),
-                                            FrameSize * 8);
+            ps = table->GetChunkSuccessRate(wifiMode, txVector, snr, frameSizeBits);
             if (ps < 0.0 || ps > 1.0)
             {
                 // error
                 exit(1);
             }
-            tabledataset.Add(snr, ps);
+            tabledataset.Add(snrDb, ps);
         }
 
         yansplot.AddDataset(yansdataset);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/examples/wireless/wifi-ofdm-vht-validation.cc ns-3.40/examples/wireless/wifi-ofdm-vht-validation.cc
--- ns-3.39/examples/wireless/wifi-ofdm-vht-validation.cc	2023-07-05 14:23:47.669427000 -0700
+++ ns-3.40/examples/wireless/wifi-ofdm-vht-validation.cc	2023-09-27 13:30:37.610839000 -0700
@@ -36,7 +36,7 @@
 int
 main(int argc, char* argv[])
 {
-    uint32_t FrameSize = 1500; // bytes
+    uint32_t frameSizeBytes = 1500;
     std::ofstream yansfile("yans-frame-success-rate-ac.plt");
     std::ofstream nistfile("nist-frame-success-rate-ac.plt");
     std::ofstream tablefile("table-frame-success-rate-ac.plt");
@@ -54,7 +54,7 @@
     };
 
     CommandLine cmd(__FILE__);
-    cmd.AddValue("FrameSize", "The frame size in bytes", FrameSize);
+    cmd.AddValue("FrameSize", "The frame size in bytes", frameSizeBytes);
     cmd.Parse(argc, argv);
 
     Gnuplot yansplot = Gnuplot("yans-frame-success-rate-ac.eps");
@@ -66,48 +66,45 @@
     Ptr<TableBasedErrorRateModel> table = CreateObject<TableBasedErrorRateModel>();
     WifiTxVector txVector;
 
-    for (uint32_t i = 0; i < modes.size(); i++)
+    uint32_t frameSizeBits = frameSizeBytes * 8;
+
+    for (const auto& mode : modes)
     {
-        std::cout << modes[i] << std::endl;
-        Gnuplot2dDataset yansdataset(modes[i]);
-        Gnuplot2dDataset nistdataset(modes[i]);
-        Gnuplot2dDataset tabledataset(modes[i]);
-        txVector.SetMode(modes[i]);
+        std::cout << mode << std::endl;
+        Gnuplot2dDataset yansdataset(mode);
+        Gnuplot2dDataset nistdataset(mode);
+        Gnuplot2dDataset tabledataset(mode);
+        txVector.SetMode(mode);
+
+        WifiMode wifiMode(mode);
 
-        for (double snr = -5.0; snr <= 30.0; snr += 0.1)
+        for (double snrDb = -5.0; snrDb <= 30.0; snrDb += 0.1)
         {
-            double ps = yans->GetChunkSuccessRate(WifiMode(modes[i]),
-                                                  txVector,
-                                                  std::pow(10.0, snr / 10.0),
-                                                  FrameSize * 8);
+            double snr = std::pow(10.0, snrDb / 10.0);
+
+            double ps = yans->GetChunkSuccessRate(wifiMode, txVector, snr, frameSizeBits);
             if (ps < 0.0 || ps > 1.0)
             {
                 // error
                 exit(1);
             }
-            yansdataset.Add(snr, ps);
+            yansdataset.Add(snrDb, ps);
 
-            ps = nist->GetChunkSuccessRate(WifiMode(modes[i]),
-                                           txVector,
-                                           std::pow(10.0, snr / 10.0),
-                                           FrameSize * 8);
+            ps = nist->GetChunkSuccessRate(wifiMode, txVector, snr, frameSizeBits);
             if (ps < 0.0 || ps > 1.0)
             {
                 // error
                 exit(1);
             }
-            nistdataset.Add(snr, ps);
+            nistdataset.Add(snrDb, ps);
 
-            ps = table->GetChunkSuccessRate(WifiMode(modes[i]),
-                                            txVector,
-                                            std::pow(10.0, snr / 10.0),
-                                            FrameSize * 8);
+            ps = table->GetChunkSuccessRate(wifiMode, txVector, snr, frameSizeBits);
             if (ps < 0.0 || ps > 1.0)
             {
                 // error
                 exit(1);
             }
-            tabledataset.Add(snr, ps);
+            tabledataset.Add(snrDb, ps);
         }
 
         yansplot.AddDataset(yansdataset);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/examples/wireless/wifi-power-adaptation-distance.cc ns-3.40/examples/wireless/wifi-power-adaptation-distance.cc
--- ns-3.39/examples/wireless/wifi-power-adaptation-distance.cc	2023-07-05 14:23:47.669427000 -0700
+++ ns-3.40/examples/wireless/wifi-power-adaptation-distance.cc	2023-09-27 13:30:37.610839000 -0700
@@ -253,7 +253,7 @@
         txVector.SetMode(mode);
         txVector.SetPreambleType(WIFI_PREAMBLE_LONG);
         txVector.SetChannelWidth(phy->GetChannelWidth());
-        DataRate dataRate = DataRate(mode.GetDataRate(phy->GetChannelWidth()));
+        DataRate dataRate(mode.GetDataRate(phy->GetChannelWidth()));
         Time time = phy->CalculateTxDuration(packetSize, txVector, phy->GetPhyBand());
         NS_LOG_DEBUG(mode.GetUniqueName() << " " << time.GetSeconds() << " " << dataRate);
         m_timeTable.emplace_back(time, dataRate);
@@ -263,7 +263,7 @@
 Time
 NodeStatistics::GetCalcTxTime(DataRate rate)
 {
-    for (TxTime::const_iterator i = m_timeTable.begin(); i != m_timeTable.end(); i++)
+    for (auto i = m_timeTable.begin(); i != m_timeTable.end(); i++)
     {
         if (rate == i->second)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/examples/wireless/wifi-power-adaptation-interference.cc ns-3.40/examples/wireless/wifi-power-adaptation-interference.cc
--- ns-3.39/examples/wireless/wifi-power-adaptation-interference.cc	2023-07-05 14:23:47.669427000 -0700
+++ ns-3.40/examples/wireless/wifi-power-adaptation-interference.cc	2023-09-27 13:30:37.610839000 -0700
@@ -274,7 +274,7 @@
         txVector.SetMode(mode);
         txVector.SetPreambleType(WIFI_PREAMBLE_LONG);
         txVector.SetChannelWidth(phy->GetChannelWidth());
-        DataRate dataRate = DataRate(mode.GetDataRate(phy->GetChannelWidth()));
+        DataRate dataRate(mode.GetDataRate(phy->GetChannelWidth()));
         Time time = phy->CalculateTxDuration(packetSize, txVector, phy->GetPhyBand());
         NS_LOG_DEBUG(mode.GetUniqueName() << " " << time.GetSeconds() << " " << dataRate);
         m_timeTable.emplace_back(time, dataRate);
@@ -284,7 +284,7 @@
 Time
 NodeStatistics::GetCalcTxTime(DataRate rate)
 {
-    for (TxTime::const_iterator i = m_timeTable.begin(); i != m_timeTable.end(); i++)
+    for (auto i = m_timeTable.begin(); i != m_timeTable.end(); i++)
     {
         if (rate == i->second)
         {
@@ -667,9 +667,7 @@
 
     Ptr<Ipv4FlowClassifier> classifier = DynamicCast<Ipv4FlowClassifier>(flowmon.GetClassifier());
     std::map<FlowId, FlowMonitor::FlowStats> stats = monitor->GetFlowStats();
-    for (std::map<FlowId, FlowMonitor::FlowStats>::const_iterator i = stats.begin();
-         i != stats.end();
-         ++i)
+    for (auto i = stats.begin(); i != stats.end(); ++i)
     {
         Ipv4FlowClassifier::FiveTuple t = classifier->FindFlow(i->first);
         if ((t.sourceAddress == "10.1.1.3" && t.destinationAddress == "10.1.1.1"))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/examples/wireless/wifi-rate-adaptation-distance.cc ns-3.40/examples/wireless/wifi-rate-adaptation-distance.cc
--- ns-3.39/examples/wireless/wifi-rate-adaptation-distance.cc	2023-07-05 14:23:47.669427000 -0700
+++ ns-3.40/examples/wireless/wifi-rate-adaptation-distance.cc	2023-09-27 13:30:37.610839000 -0700
@@ -403,8 +403,8 @@
     std::ofstream outfile("throughput-" + outputFileName + ".plt");
     Gnuplot gnuplot = Gnuplot("throughput-" + outputFileName + ".eps", "Throughput");
     gnuplot.SetTerminal("post eps color enhanced");
-    gnuplot.SetLegend("Time (seconds)", "Throughput (Mb/s)");
-    gnuplot.SetTitle("Throughput (AP to STA) vs time");
+    gnuplot.SetLegend("Distance (meters)", "Throughput (Mb/s)");
+    gnuplot.SetTitle("Throughput (AP to STA) vs distance");
     gnuplot.AddDataset(atpCounter.GetDatafile());
     gnuplot.GenerateOutput(outfile);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/examples/wireless/wifi-simple-ht-hidden-stations.cc ns-3.40/examples/wireless/wifi-simple-ht-hidden-stations.cc
--- ns-3.39/examples/wireless/wifi-simple-ht-hidden-stations.cc	2023-07-05 14:23:47.669427000 -0700
+++ ns-3.40/examples/wireless/wifi-simple-ht-hidden-stations.cc	2023-09-27 13:30:37.610839000 -0700
@@ -59,7 +59,7 @@
     double simulationTime = 10;  // seconds
     uint32_t nMpdus = 1;
     uint32_t maxAmpduSize = 0;
-    bool enableRts = 0;
+    bool enableRts = false;
     double minExpectedThroughput = 0;
     double maxExpectedThroughput = 0;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/examples/wireless/wifi-sleep.cc ns-3.40/examples/wireless/wifi-sleep.cc
--- ns-3.39/examples/wireless/wifi-sleep.cc	2023-07-05 14:23:47.669427000 -0700
+++ ns-3.40/examples/wireless/wifi-sleep.cc	2023-09-27 13:30:37.610839000 -0700
@@ -228,7 +228,7 @@
                                         DoubleValue(eta));
 
     // install an energy source on each node
-    for (NodeContainer::Iterator n = c.Begin(); n != c.End(); n++)
+    for (auto n = c.Begin(); n != c.End(); n++)
     {
         eSources.Add(basicSourceHelper.Install(*n));
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/examples/wireless/wifi-txop-aggregation.cc ns-3.40/examples/wireless/wifi-txop-aggregation.cc
--- ns-3.39/examples/wireless/wifi-txop-aggregation.cc	2023-07-05 14:23:47.669427000 -0700
+++ ns-3.40/examples/wireless/wifi-txop-aggregation.cc	2023-09-27 13:30:37.610839000 -0700
@@ -111,9 +111,9 @@
     double simulationTime = 10;  // seconds
     double txopLimit = 3520;     // microseconds
     double distance = 5;         // meters
-    bool enableRts = 0;
-    bool enablePcap = 0;
-    bool verifyResults = 0; // used for regression
+    bool enableRts = false;
+    bool enablePcap = false;
+    bool verifyResults = false; // used for regression
 
     CommandLine cmd(__FILE__);
     cmd.AddValue("payloadSize", "Payload size in bytes", payloadSize);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/examples/wireless/wifi-vht-network.cc ns-3.40/examples/wireless/wifi-vht-network.cc
--- ns-3.39/examples/wireless/wifi-vht-network.cc	2023-07-05 14:23:47.669427000 -0700
+++ ns-3.40/examples/wireless/wifi-vht-network.cc	2023-09-27 13:30:37.610839000 -0700
@@ -117,7 +117,7 @@
                 channelWidth *= 2;
                 continue;
             }
-            for (int sgi = 0; sgi < 2; sgi++)
+            for (auto sgi : {false, true})
             {
                 uint32_t payloadSize; // 1500 byte IP packet
                 if (udp)
@@ -265,11 +265,11 @@
 
                 Simulator::Destroy();
 
-                std::cout << mcs << "\t\t\t" << channelWidth << " MHz\t\t\t" << sgi << "\t\t\t"
-                          << throughput << " Mbit/s" << std::endl;
+                std::cout << mcs << "\t\t\t" << channelWidth << " MHz\t\t\t" << std::boolalpha
+                          << sgi << "\t\t\t" << throughput << " Mbit/s" << std::endl;
 
                 // test first element
-                if (mcs == 0 && channelWidth == 20 && sgi == 0)
+                if (mcs == 0 && channelWidth == 20 && !sgi)
                 {
                     if (throughput < minExpectedThroughput)
                     {
@@ -278,7 +278,7 @@
                     }
                 }
                 // test last element
-                if (mcs == 9 && channelWidth == 160 && sgi == 1)
+                if (mcs == 9 && channelWidth == 160 && sgi)
                 {
                     if (maxExpectedThroughput > 0 && throughput > maxExpectedThroughput)
                     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/ns3 ns-3.40/ns3
--- ns-3.39/ns3	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/ns3	2023-09-27 13:30:37.610839000 -0700
@@ -167,13 +167,14 @@
         parser_configure = on_off_argument(parser_configure, *on_off_option)
 
     parser_configure.add_argument('--enable-modules',
-                                  help='List of modules to build (e.g. core;network;internet)',
+                                  help='List of modules to build (e.g. \"core;network;internet\")',
                                   action="store", type=str, default=None)
     parser_configure.add_argument('--disable-modules',
-                                  help='List of modules not to build (e.g. lte;wimax)',
+                                  help='List of modules not to build (e.g. \"lte;wimax\")',
                                   action="store", type=str, default=None)
     parser_configure.add_argument('--filter-module-examples-and-tests',
-                                  help='List of modules that should have their examples and tests built (e.g. lte;wifi)',
+                                  help=('List of modules that should have their examples '
+                                        'and tests built (e.g. \"lte;wifi\")'),
                                   action="store", type=str, default=None)
     parser_configure.add_argument('--lcov-report',
                                   help=('Generate a code coverage report '
@@ -429,7 +430,8 @@
 def remove_dir(dir_to_remove, dry_run, directory_qualifier=""):
     dir_to_remove = os.path.abspath(dir_to_remove)
     if os.path.exists(dir_to_remove):
-        if ".." in os.path.relpath(dir_to_remove, ns3_path):
+        if (".." in os.path.relpath(dir_to_remove, ns3_path)
+            or os.path.abspath(dir_to_remove) == os.path.abspath(ns3_path)):
             # In case the directory to remove isn't within
             # the current ns-3 directory, print an error
             # message for the dry-run case
@@ -505,6 +507,10 @@
         remove_dir(directory, dry_run)
 
 
+def clean_vcpkg_artifacts(dry_run=False):
+    remove_dir(os.path.join(ns3_path, "vcpkg"), dry_run)
+
+
 def search_cmake_cache(build_profile):
     # Search for the CMake cache
     cmake_cache_files = glob.glob("%s/**/CMakeCache.txt" % ns3_path, recursive=True)
@@ -1445,6 +1451,7 @@
         clean_cmake_artifacts(dry_run=args.dry_run)
         clean_docs_and_tests_artifacts(dry_run=args.dry_run)
         clean_pip_packaging_artifacts(dry_run=args.dry_run)
+        clean_vcpkg_artifacts(dry_run=args.dry_run)
         # We end things earlier when cleaning
         return
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/antenna/model/angles.cc ns-3.40/src/antenna/model/angles.cc
--- ns-3.39/src/antenna/model/angles.cc	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/antenna/model/angles.cc	2023-09-27 13:30:37.610839000 -0700
@@ -74,55 +74,85 @@
 double
 WrapTo360(double a)
 {
-    a = fmod(a, 360);
-    if (a < 0)
+    static constexpr int64_t INT_RANGE = 100000000000;
+    // Divide the input by 360.
+    // Multiply it by INT_RANGE and store into an integer.
+    int64_t b(a / (360.0) * INT_RANGE);
+    // Clamp it between [-INT_RANGE / 2, INT_RANGE / 2)
+    b = b % INT_RANGE;
+    if (b < 0)
     {
-        a += 360;
+        b += INT_RANGE;
     }
-
-    NS_ASSERT_MSG(0 <= a && a < 360, "Invalid wrap, a=" << a);
-    return a;
+    else if (b >= INT_RANGE)
+    {
+        b -= INT_RANGE;
+    }
+    // Divide by INT_RANGE and multiply by 360.
+    return b * (360.0) / INT_RANGE;
 }
 
 double
 WrapTo180(double a)
 {
-    a = fmod(a + 180, 360);
-    if (a < 0)
+    static constexpr int64_t INT_RANGE = 100000000000;
+    // Divide the input by 360.
+    // Multiply it by INT_RANGE and store into an integer.
+    int64_t b(a / (360.0) * INT_RANGE);
+    // Clamp it between [-INT_RANGE / 2, INT_RANGE / 2)
+    b = b % INT_RANGE;
+    if (b < -INT_RANGE / 2)
     {
-        a += 360;
+        b += INT_RANGE;
     }
-    a -= 180;
-
-    NS_ASSERT_MSG(-180 <= a && a < 180, "Invalid wrap, a=" << a);
-    return a;
+    else if (b >= INT_RANGE / 2)
+    {
+        b -= INT_RANGE;
+    }
+    // Divide by INT_RANGE and multiply by 360.
+    return b * (360.0) / INT_RANGE;
 }
 
 double
 WrapTo2Pi(double a)
 {
-    a = fmod(a, 2 * M_PI);
-    if (a < 0)
+    static constexpr int64_t INT_RANGE = 100000000000;
+    // Divide the input by 2*M_PI.
+    // Multiply it by INT_RANGE and store into an integer.
+    int64_t b(a / (2 * M_PI) * INT_RANGE);
+    // Clamp it between [-INT_RANGE / 2, INT_RANGE / 2)
+    b = b % INT_RANGE;
+    if (b < 0)
     {
-        a += 2 * M_PI;
+        b += INT_RANGE;
     }
-
-    NS_ASSERT_MSG(0 <= a && a < 2 * M_PI, "Invalid wrap, a=" << a);
-    return a;
+    else if (b >= INT_RANGE)
+    {
+        b -= INT_RANGE;
+    }
+    // Divide by INT_RANGE and multiply by 2*M_PI.
+    return b * (2 * M_PI) / INT_RANGE;
 }
 
 double
 WrapToPi(double a)
 {
-    a = fmod(a + M_PI, 2 * M_PI);
-    if (a < 0)
+    static constexpr int64_t INT_RANGE = 100000000000;
+    // Divide the input by 2*M_PI.
+    // Multiply it by INT_RANGE and store into an integer.
+    int64_t b(a / (2 * M_PI) * INT_RANGE);
+    // Clamp it between [-INT_RANGE / 2, INT_RANGE / 2)
+    b = b % INT_RANGE;
+    if (b < -INT_RANGE / 2)
     {
-        a += 2 * M_PI;
+        b += INT_RANGE;
     }
-    a -= M_PI;
-
-    NS_ASSERT_MSG(-M_PI <= a && a < M_PI, "Invalid wrap, a=" << a);
-    return a;
+    else if (b >= INT_RANGE / 2)
+    {
+        b -= INT_RANGE;
+    }
+    // Divide by INT_RANGE and multiply by 2*M_PI.
+    return b * (2 * M_PI) / INT_RANGE;
 }
 
 std::ostream&
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/antenna/model/antenna-model.h ns-3.40/src/antenna/model/antenna-model.h
--- ns-3.39/src/antenna/model/antenna-model.h	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/antenna/model/antenna-model.h	2023-09-27 13:30:37.610839000 -0700
@@ -20,7 +20,8 @@
 #ifndef ANTENNA_MODEL_H
 #define ANTENNA_MODEL_H
 
-#include <ns3/angles.h>
+#include "angles.h"
+
 #include <ns3/object.h>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/antenna/model/cosine-antenna-model.h ns-3.40/src/antenna/model/cosine-antenna-model.h
--- ns-3.39/src/antenna/model/cosine-antenna-model.h	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/antenna/model/cosine-antenna-model.h	2023-09-27 13:30:37.610839000 -0700
@@ -20,7 +20,8 @@
 #ifndef COSINE_ANTENNA_MODEL_H
 #define COSINE_ANTENNA_MODEL_H
 
-#include <ns3/antenna-model.h>
+#include "antenna-model.h"
+
 #include <ns3/object.h>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/antenna/model/isotropic-antenna-model.h ns-3.40/src/antenna/model/isotropic-antenna-model.h
--- ns-3.39/src/antenna/model/isotropic-antenna-model.h	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/antenna/model/isotropic-antenna-model.h	2023-09-27 13:30:37.610839000 -0700
@@ -20,7 +20,8 @@
 #ifndef ISOTROPIC_ANTENNA_MODEL_H
 #define ISOTROPIC_ANTENNA_MODEL_H
 
-#include <ns3/antenna-model.h>
+#include "antenna-model.h"
+
 #include <ns3/object.h>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/antenna/model/parabolic-antenna-model.h ns-3.40/src/antenna/model/parabolic-antenna-model.h
--- ns-3.39/src/antenna/model/parabolic-antenna-model.h	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/antenna/model/parabolic-antenna-model.h	2023-09-27 13:30:37.610839000 -0700
@@ -20,7 +20,8 @@
 #ifndef PARABOLIC_ANTENNA_MODEL_H
 #define PARABOLIC_ANTENNA_MODEL_H
 
-#include <ns3/antenna-model.h>
+#include "antenna-model.h"
+
 #include <ns3/object.h>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/antenna/model/phased-array-model.cc ns-3.40/src/antenna/model/phased-array-model.cc
--- ns-3.39/src/antenna/model/phased-array-model.cc	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/antenna/model/phased-array-model.cc	2023-09-27 13:30:37.610839000 -0700
@@ -17,9 +17,10 @@
 
 #include "phased-array-model.h"
 
+#include "isotropic-antenna-model.h"
+
 #include <ns3/boolean.h>
 #include <ns3/double.h>
-#include <ns3/isotropic-antenna-model.h>
 #include <ns3/log.h>
 #include <ns3/pointer.h>
 #include <ns3/uinteger.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/antenna/model/phased-array-model.h ns-3.40/src/antenna/model/phased-array-model.h
--- ns-3.39/src/antenna/model/phased-array-model.h	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/antenna/model/phased-array-model.h	2023-09-27 13:30:37.610839000 -0700
@@ -18,8 +18,9 @@
 #ifndef PHASED_ARRAY_MODEL_H
 #define PHASED_ARRAY_MODEL_H
 
-#include <ns3/angles.h>
-#include <ns3/antenna-model.h>
+#include "angles.h"
+#include "antenna-model.h"
+
 #include <ns3/matrix-array.h>
 #include <ns3/object.h>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/antenna/model/three-gpp-antenna-model.h ns-3.40/src/antenna/model/three-gpp-antenna-model.h
--- ns-3.39/src/antenna/model/three-gpp-antenna-model.h	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/antenna/model/three-gpp-antenna-model.h	2023-09-27 13:30:37.610839000 -0700
@@ -18,7 +18,8 @@
 #ifndef THREE_GPP_ANTENNA_MODEL_H
 #define THREE_GPP_ANTENNA_MODEL_H
 
-#include <ns3/antenna-model.h>
+#include "antenna-model.h"
+
 #include <ns3/object.h>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/antenna/model/uniform-planar-array.h ns-3.40/src/antenna/model/uniform-planar-array.h
--- ns-3.39/src/antenna/model/uniform-planar-array.h	2023-07-05 14:23:47.673426900 -0700
+++ ns-3.40/src/antenna/model/uniform-planar-array.h	2023-09-27 13:30:37.610839000 -0700
@@ -18,8 +18,9 @@
 #ifndef UNIFORM_PLANAR_ARRAY_H
 #define UNIFORM_PLANAR_ARRAY_H
 
+#include "phased-array-model.h"
+
 #include <ns3/object.h>
-#include <ns3/phased-array-model.h>
 
 namespace ns3
 {
